CXX = g++
LEX = flex
M4 = m4
YACC = bison
CXXFLAGS = -g -O3 -Wall -Wextra

M4FLAGS = -DCHAR_BITS=CHAR_BITS -DWORD_BITS=WORD_BITS -DWORD_CHARS=WORD_CHARS`'ifdef(`B_ENDIAN_BIG',` -DB_ENDIAN_BIG')`'ifdef(`EXTENSIONS',` -DEXTENSIONS')
CPPFLAGS = -DCHAR_BITS=CHAR_BITS -DWORD_BITS=WORD_BITS -DWORD_CHARS=WORD_CHARS`'ifdef(`B_ENDIAN_BIG',` -DB_ENDIAN_BIG')`'ifdef(`EXTENSIONS',` -DEXTENSIONS')
OBJECTS = aslexer.o assemble.o ba.o balist.o bc.o bi.o br.o compile.o definition.o dump.o execute.o expression.o lexer.o parser.o statement.o
PROGS = bc ba br balist
B_LIBS = char.ba lchar.ba printf.ba printn.ba

.PHONY: all check clean maintainer-clean

.SECONDARY: aslexer.cc ba.o br.o char.b lchar.b lexer.cc lexer.l parser.cc parser.y

.SUFFIXES:

all: $(PROGS) libb.ba

check: all
	cd test && ./test CHAR_BITS WORD_BITS WORD_CHARS ifdef(`B_ENDIAN_BIG', big, little) ifdef(`EXTENSIONS', 1, 0)

clean:
	$(RM) $(PROGS) $(OBJECTS) $(OBJECTS:.o=.d) $(B_LIBS) libb.ba

maintainer-clean: clean
	$(RM) parser.cc parser.hh
	$(RM) aslexer.cc aslexer.hh lexer.cc lexer.hh
	$(RM) char.b lchar.b lexer.l parser.y

%:: %.m4
	$(M4) $(M4FLAGS) $^ > $@

%.cc %.hh: %.l
	$(LEX) $<

%.cc %.hh: %.y
	$(YACC) $<

-`include' $(OBJECTS:.o=.d)
assemble.o balist.o: aslexer.hh
bc.o parser.o: lexer.hh
bc.o lexer.o: parser.hh

%.o: %.cc
	$(CXX) $(CXXFLAGS) $(CPPFLAGS) -c $< -o $@
	$(CXX) $(CXXFLAGS) $(CPPFLAGS) -MM -MF $*.d -MP $<

bc: compile.o definition.o dump.o expression.o lexer.o parser.o statement.o
ba: aslexer.o assemble.o
br: execute.o
balist: aslexer.o

%: %.o
	$(CXX) $(CXXFLAGS) $(LDFLAGS) $^ $(LOADLIBES) $(LDLIBS) -o $@

%.ba: %.b bc
	./bc -o $@ $<

libb.ba: bcore.ba $(B_LIBS)
	cat $^ > $@
