%{
#include "astokens.hh"

#include <cctype>
#include <cstdio>

static void allupper(char *s)
{
    for ( ; *s; s++)
        *s = toupper(*s);
}
%}

%option header-file="aslexer.hh" outfile="aslexer.cc"
%option case-insensitive yylineno noyywrap
%option reentrant extra-type="aslexer_extra *"

%option nodefault warn

%%

;             return TK_SEMICOLON;

A             return TK_REG_A;
D             return TK_REG_D;
"(D)"         return TK_REG_D_DEREF;
S             return TK_REG_S;
S\+           return TK_REG_S_PLUS;
S-            return TK_REG_S_MINUS;

Z             return TK_FLAG_Z;

[A-Z]+        allupper(yytext); return TK_INSTN;

\.[A-Z_0-9.]+ return TK_VALUE;
-?[0-9]+      return TK_VALUE;

#.*           { if (yyextra->want_comments)
                    return TK_COMMENT; }

[ \r\n\t]+    /* Skip whitespace. */

.             { printf("Unrecognized character: %s\n", yytext);
                return -1; }
