#ifndef ASLEXER_WRAP_HPP
#define ASLEXER_WRAP_HPP

#include "astokens.hh"
#include "aslexer.hh"

class aslexer
{
    yyscan_t scanner;
    aslexer_extra extra;
    
    aslexer(const aslexer &); // = delete
    aslexer &operator =(const aslexer &); // = delete
    
public:
    aslexer(bool comments = false)
    {
        extra.want_comments = comments;
        yylex_init_extra(&extra, &scanner);
    }
    ~aslexer() { yylex_destroy(scanner); }
    
    void set_in(FILE *f) { yyset_in(f, scanner); }
    astoken lex() { return (astoken)yylex(scanner); }
    char *get_text() { return yyget_text(scanner); }
    int get_lineno() { return yyget_lineno(scanner); }
};

#endif
