#ifndef ASSEMBLE_HPP
#define ASSEMBLE_HPP

#include "machine.hh"

#include <cstdio>
#include <iosfwd>
#include <map>
#include <string>
#include <vector>

struct need_sym
{
    std::size_t address;
    std::string name;
};
typedef std::vector<need_sym> need_sym_vec;

typedef std::map<std::string, std::size_t> found_sym_map;

class assembler
{
    std::vector<uword_t> memory;
    need_sym_vec         needed_symbols;
    found_sym_map        found_symbols;
    
    void add_value(const char *value);
    
public:
    bool assemble(FILE *fasm);
    bool link();
    void write_data(std::ostream& fout) const;
};

#endif
