#include "ast.hh"

definition::definition(definitiontype type, char *name) :
    type(type),
    sval(name),
    vlen(0),
    initialiser(0),
    args(0),
    stmt(0),
    next(0)
{
}

definition::~definition()
{
    delete sval;
    delete vlen;
    delete initialiser;
    delete args;
    delete stmt;
    delete next;
}

definition *definition::make_simple(char *name, expressions *initialiser)
{
    definition *result = new definition(DEF_SIMPLE, name);
    result->initialiser = initialiser;
    return result;
}

definition *definition::make_vector(char *name, expression *vlen, expressions *initialiser)
{
    definition *result = new definition(DEF_VECTOR, name);
    result->vlen = vlen;
    result->initialiser = initialiser;
    return result;
}

definition *definition::make_function(char *name, var_decl *args, statement *stmt)
{
    definition *result = new definition(DEF_FUNCTION, name);
    result->args = args;
    result->stmt = stmt;
    return result;
}
