#ifndef MACHINE_HPP
#define MACHINE_HPP

#include <climits>

#if WORD_CHARS * CHAR_BITS > WORD_BITS
#error "The specified number of characters do not fit in a word."
#endif

#if UINT_MAX >> WORD_BITS-1 != 0
typedef unsigned int uword_t;
typedef int sword_t;
#define WORDFORMAT ""
#define UWORD_MAX ((1U << WORD_BITS) - 1)
#define SWORD_MIN (1U << (WORD_BITS-1))
#define SWORD_MAX (SWORD_MIN - 1)

#elif ULONG_MAX >> WORD_BITS-1 != 0
typedef unsigned long uword_t;
typedef long sword_t;
#define WORDFORMAT "l"
#define UWORD_MAX ((1LU << WORD_BITS) - 1)
#define SWORD_MIN (1LU << (WORD_BITS-1))
#define SWORD_MAX (SWORD_MIN - 1)

#elif ULLONG_MAX >> WORD_BITS-1 != 0
typedef unsigned long long uword_t;
typedef long long sword_t;
#define WORDFORMAT "ll"
#define UWORD_MAX ((1LLU << WORD_BITS) - 1)
#define SWORD_MIN (1LLU << (WORD_BITS-1))
#define SWORD_MAX (SWORD_MIN - 1)

#else
#error "No type large enough for machine word"
#endif

inline uword_t atoword(const char *s)
{
    uword_t result = 0;
    uword_t base = *s == '0' ? 8 : 10;
    
    while (*s)
        result = result * base + (*s++ - '0');
    
    return result & UWORD_MAX;
}

enum instructions
{
#define INSTRUCTION(name, size) MI_ ## name,
#include "instructions.def"
    MI__COUNT
};

#endif
