/* Reads a decimal number from standard input and returns it. The number is an
 * optional '+' or '-' character followed by one or more digits.  Any amount
 * of whitespace is ignored before the number; the first non-digit character
 * after the number is completely lost, as ungetc() has not yet been invented.
 */

scann() {
   extrn getchar;
   auto res, neg, c;

   neg = 0;

start:
   switch c = getchar() {
   case '*e':
      return(0);

   case '*t':
   case '*n':
   case ' ':
      goto start;

   case '-':
      neg = 1;
   case '+':
      c = getchar();
   }

   res = 0;
   while(c >= '0' & c <= '9') {
      res =* 10;
      res =+ c - '0';
      c = getchar();
   }

   return(neg ? -res : res);
}
